/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_LIDARPOINTCLOUDNEW_H
#define IMPL_TYPE_LIDARPOINTCLOUDNEW_H

#include "impl_type_vector_lidarpoints.h"
#include "impl_type_driverheader.h"

struct LidarPointCloudNew {
    ::vector_LiDARPoints data;
    ::DriverHeader header;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(data);
        fun(header);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(data);
        fun(header);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("data", data);
        fun("header", header);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("data", data);
        fun("header", header);
    }

    friend bool operator==(const ::LidarPointCloudNew& lhs, const ::LidarPointCloudNew& rhs) noexcept
    {
        return (lhs.data == rhs.data) && (lhs.header == rhs.header);
    }
};


#endif // IMPL_TYPE_LIDARPOINTCLOUDNEW_H
